//+------------------------------------------------------------------+
//|                                 painted moving average cross.mq4 |
//|                                                           .....h |
//|                                                  ibfx forum crew |
//+------------------------------------------------------------------+
#property copyright ".....h"
#property link      "ibfx forum crew"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 7
#property  indicator_color1  Lime
#property  indicator_color2  Red
#property  indicator_color3  Lime
#property  indicator_color4  Red
#property  indicator_color5  Lime
#property  indicator_color6  Red

//---- indicator parameters

extern int stochk             = 10;
extern int stochd             =  5;
extern int stochs             =  3;

extern int stoch_high_val     = 80;
extern int stoch_low_val      = 20;

extern int rviperiod          = 10;
extern double rvithreshold    =  0;

extern int a                  =  1;

double     ind_buffer1[];
double     ind_buffer2[];

int        HighBarBuffer[];
int        LowBarBuffer[];
double     MacdBuffer[];


//---- indicator buffers
double     CrossUp[];
double     CrossDown[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 
  {

   //----
   IndicatorBuffers(7);
   SetIndexBuffer(2, HighBarBuffer);
   SetIndexBuffer(3, LowBarBuffer);

   //---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
  
   SetIndexBuffer(4, CrossUp);
   SetIndexStyle(4, DRAW_ARROW, EMPTY,3,Lime);
   SetIndexArrow(4, 233);
   
   SetIndexBuffer(5, CrossDown);
   SetIndexStyle(5, DRAW_ARROW, EMPTY,3,Red);
   SetIndexArrow(5, 234);
   
  IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   
  
   if(!SetIndexBuffer(0,ind_buffer1) && !SetIndexBuffer(1,ind_buffer2)
   && !SetIndexBuffer(2,HighBarBuffer) && !SetIndexBuffer(3,LowBarBuffer))
      Print("cannot set indicator buffers!");
      
   
   //---- initialization done
   return(0);
   
  }
  
 //------------------------------------------------------------------
 int deinit()
   { 
   
   ObjectDelete("Label1");
    return(0);
   } 
 
 
 
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  drawLabel("Label1"," stochastic painted",15,Lime,50,50,"Arial");
   int      limit,i,counter; 
   int      counted_bars=IndicatorCounted();
   double Range, AvgRange;
    //---- check for possible errors
   if(counted_bars<0) return(-1);
   
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   //----Calculation---------------------------
   for( i=0; i<limit; i++)
   {
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++) {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
    Range      =AvgRange/10;
    
    double stoch = iStochastic(NULL,0,stochk,stochd,stochs,MODE_SMA,0,MODE_MAIN,i);
    double stochsig = iStochastic(NULL,0,stochk,stochd,stochs,MODE_SMA,0,MODE_SIGNAL,i);
    
    
    double rvi =iRVI(NULL, 0,rviperiod,MODE_MAIN,i);
    double rvi1 =iRVI(NULL, 0,rviperiod,MODE_MAIN,i+1);
       
      if(stoch>stochsig) 
       {
         ind_buffer2[i]=Low[i];
         ind_buffer1[i]=High[i];
       }

      if(stochsig>stoch) 
       {
         ind_buffer1[i]=Low[i];
         ind_buffer2[i]=High[i];
       }
     
     
     if ((rvi > rvithreshold) && (rvi1< rvithreshold))
      {
         CrossUp[i] =Low[i] - Range*1;
      }
      else if ((rvi < rvithreshold) && (rvi1 > rvithreshold)) 
      {
        CrossDown[i] = High[i] + Range*1;
      }
      }
   //---- done

   return(0);
  }
  
  void drawLabel(string id, string text,int fsize, color fcolor,int x,int y,string font="Arial",int window = 0)
{
      if(ObjectFind(id)==-1)
      { 
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 0);
        ObjectSet(id, OBJPROP_XDISTANCE, x);
        ObjectSet(id, OBJPROP_YDISTANCE, y);
      }
      else
      {
        
        ObjectDelete(id);
         
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 0);
        ObjectSet(id, OBJPROP_XDISTANCE, x);
        ObjectSet(id, OBJPROP_YDISTANCE, y);   
      }  
}